﻿using System;
using System.Windows.Forms;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;


namespace  TestLegendAdornmentLayer
{
    public partial class TestForm : Form
    {
        public TestForm()
        {
            InitializeComponent();
        }

        private void TestForm_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            // Draw thematic features
            ClassBreakStyle classBreakStyle = new ClassBreakStyle("POP_CNTRY");
            classBreakStyle.ClassBreaks.Add(new ClassBreak(double.MinValue, AreaStyles.Grass1));
            LegendItem item1 = new LegendItem();
            item1.Image = new GeoImage(@"C:\Users\chenzhiyong.APTHINKGEO\Desktop\ThinkGeo\DesktopEditionSample_LegendAdornmentLayer_CS_100215\LegendAdornmentLayer\data\legend1.jpg");
            item1.Text = "LegendItem1";
            item1.ImageTopPadding = 10;
            item1.ImageLeftPadding = 10;
            item1.TextFont = new GeoFont("Tahoma", 10);
            item1.TextSolidBrush = new GeoSolidBrush(GeoColor.SimpleColors.BrightRed);
            item1.TextTopPadding = 10;
            item1.TextLeftPadding = 10;
            item1.ImageMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.BrightBlue));
            item1.TextMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.DarkOrange));
            item1.TopPadding = 10;
            item1.LeftPadding = 10;
            item1.ImageBottomPadding = 10;
            item1.ImageRightPadding = 10;
            item1.TextBottomPadding = 10;
            item1.TextRightPadding = 10;

            classBreakStyle.ClassBreaks.Add(new ClassBreak(1000000, AreaStyles.Evergreen2));
            LegendItem item2 = new LegendItem();
            item2.Image = new GeoImage(@"C:\Users\chenzhiyong.APTHINKGEO\Desktop\ThinkGeo\DesktopEditionSample_LegendAdornmentLayer_CS_100215\LegendAdornmentLayer\data\legend2.jpg");
            item2.Text = "LegendItem2";
            item2.ImageTopPadding = 10;
            item2.ImageLeftPadding = 10;
            item2.TextFont = new GeoFont("Tahoma", 10);
            item2.TextSolidBrush = new GeoSolidBrush(GeoColor.SimpleColors.BrightRed);
            item2.TextTopPadding = 10;
            item2.TextLeftPadding = 10;
            item2.ImageMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.BrightBlue));
            item2.TextMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.DarkOrange));
            item2.TopPadding = 10;
            item2.LeftPadding = 10;
            item2.ImageBottomPadding = 10;
            item2.ImageRightPadding = 10;
            item2.TextBottomPadding = 10;
            item2.TextRightPadding = 10;

            classBreakStyle.ClassBreaks.Add(new ClassBreak(10000000, AreaStyles.Evergreen1));
            LegendItem item3 = new LegendItem();
            item3.Image = new GeoImage(@"C:\Users\chenzhiyong.APTHINKGEO\Desktop\ThinkGeo\DesktopEditionSample_LegendAdornmentLayer_CS_100215\LegendAdornmentLayer\data\legend3.jpg");
            item3.Text = "LegendItem3";
            item3.ImageTopPadding = 10;
            item3.ImageLeftPadding = 10;
            item3.TextFont = new GeoFont("Tahoma", 10);
            item3.TextSolidBrush = new GeoSolidBrush(GeoColor.SimpleColors.BrightRed);
            item3.TextTopPadding = 10;
            item3.TextLeftPadding = 10;
            item3.ImageMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.BrightBlue));
            item3.TextMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.DarkOrange));
            item3.TopPadding = 10;
            item3.LeftPadding = 10;
            item3.ImageBottomPadding = 10;
            item3.ImageRightPadding = 10;
            item3.TextBottomPadding = 10;
            item3.TextRightPadding = 10;

            LegendAdornmentLayer legendLayer = new LegendAdornmentLayer();
            legendLayer.Width = winformsMap1.Width / 10 * 8;
            legendLayer.Height = winformsMap1.Height / 10 * 8;
            legendLayer.BackgroundMask = new AreaStyle(new GeoPen(GeoColor.SimpleColors.PaleRed, 5));
            legendLayer.LegendItems.Add(item1);
            legendLayer.LegendItems.Add(item2);
            legendLayer.LegendItems.Add(item3);
            legendLayer.WordWrapLength = 30;

            classBreakStyle.ClassBreaks.Add(new ClassBreak(50000000, AreaStyles.Crop1));
            classBreakStyle.ClassBreaks.Add(new ClassBreak(100000000, AreaStyles.Forest1));

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\Data\Countries02.shp");
            worldLayer.Name = "WorldLayer";
            worldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(AreaStyles.Country1);
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            worldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(classBreakStyle);

            LayerOverlay worldOverlay = new LayerOverlay();
            worldOverlay.Name = "WorldLayerOverlay";
            worldOverlay.Layers.Add("WorldLayer", worldLayer);
            winformsMap1.Overlays.Add(worldOverlay);

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("LengendLayer", legendLayer);
            winformsMap1.Overlays.Add(staticOverlay);

            winformsMap1.CurrentExtent = new RectangleShape(-126.4, 48.8, -67.0, 19.0);
            winformsMap1.Refresh();
        }

      
        private void winformsMap1_MouseMove(object sender, MouseEventArgs e)
        {
            //Displays the X and Y in screen coordinates.
            statusStrip1.Items["toolStripStatusLabelScreen"].Text = "X:" + e.X + " Y:" + e.Y;

            //Gets the PointShape in world coordinates from screen coordinates.
            PointShape pointShape = ExtentHelper.ToWorldCoordinate(winformsMap1.CurrentExtent, new ScreenPointF(e.X, e.Y), winformsMap1.Width, winformsMap1.Height);

            //Displays world coordinates.
            statusStrip1.Items["toolStripStatusLabelWorld"].Text = "(world) X:" + Math.Round(pointShape.X, 4) + " Y:" + Math.Round(pointShape.Y, 4);
        }
        
        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
